pcl::ShadowPoints< PointT, NormalT > Class Template Reference
Module filters

ShadowPoints removes the ghost points appearing on edge discontinuties More...

`#include <pcl/filters/shadowpoints.h>`

Inheritance diagram for pcl::ShadowPoints< PointT, NormalT >:

## Public Types

typedef boost::shared_ptr< ShadowPoints< PointT, NormalT > > | Ptr
typedef boost::shared_ptr< const ShadowPoints< PointT, NormalT > > | ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ShadowPoints (bool extract_removed_indices=false)
| Empty constructor. More...
void | setNormals (const NormalsPtr &normals)
| Set the normals computed on the input point cloud. More...
NormalsPtr | getNormals () const
| Get the normals computed on the input point cloud. More...
void | setThreshold (float threshold)
| Set the threshold for shadow points rejection. More...
float | getThreshold () const
| Get the threshold for shadow points rejection. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Sample of point indices into a separate PointCloud. More...
void | applyFilter (std::vector< int > &indices)
| Sample of point indices. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

NormalsPtr | input_normals_
| The normals computed at each point in the input cloud. More...
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT, typename NormalT>
class pcl::ShadowPoints< PointT, NormalT >

ShadowPoints removes the ghost points appearing on edge discontinuties

Author
  Aravindhan K Krishnan. This code is ported from libpointmatcher (https://github.com/ethz-asl/libpointmatcher)

Definition at line 53 of file shadowpoints.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT , typename NormalT >

typedef boost::shared_ptr< const ShadowPoints<PointT, NormalT> > pcl::ShadowPoints< PointT, NormalT >::ConstPtr

Definition at line 73 of file shadowpoints.h.

## Ptr

template<typename PointT , typename NormalT >

typedef boost::shared_ptr< ShadowPoints<PointT, NormalT> > pcl::ShadowPoints< PointT, NormalT >::Ptr

Definition at line 72 of file shadowpoints.h.

## Constructor & Destructor Documentation

## ShadowPoints()

template<typename PointT , typename NormalT >

pcl::ShadowPoints< PointT, NormalT >::ShadowPoints | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 76 of file shadowpoints.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT , typename NormalT >

void pcl::ShadowPoints< PointT, NormalT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  [out] | output | the resultant point cloud

Implements pcl::FilterIndices< PointT >.

Definition at line 47 of file shadowpoints.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## applyFilter() [2/2]

template<typename PointT , typename NormalT >

void pcl::ShadowPoints< PointT, NormalT >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Sample of point indices.

Parameters

  [out] | indices | the resultant point cloud indices

Implements pcl::FilterIndices< PointT >.

Definition at line 84 of file shadowpoints.hpp.

## getNormals()

template<typename PointT , typename NormalT >

NormalsPtr pcl::ShadowPoints< PointT, NormalT >::getNormals | ( |  | ) | const

inline

Get the normals computed on the input point cloud.

Definition at line 92 of file shadowpoints.h.

References pcl::ShadowPoints< PointT, NormalT >::input_normals_.

## getThreshold()

template<typename PointT , typename NormalT >

float pcl::ShadowPoints< PointT, NormalT >::getThreshold | ( |  | ) | const

inline

Get the threshold for shadow points rejection.

Definition at line 102 of file shadowpoints.h.

## setNormals()

template<typename PointT , typename NormalT >

void pcl::ShadowPoints< PointT, NormalT >::setNormals | ( | const NormalsPtr & | normals | ) |

inline

Set the normals computed on the input point cloud.

Parameters

  [in] | normals | the normals computed for the input cloud

Definition at line 88 of file shadowpoints.h.

References pcl::ShadowPoints< PointT, NormalT >::input_normals_.

## setThreshold()

template<typename PointT , typename NormalT >

void pcl::ShadowPoints< PointT, NormalT >::setThreshold | ( | float | threshold | ) |

inline

Set the threshold for shadow points rejection.

Parameters

  [in] | threshold | the threshold

Definition at line 98 of file shadowpoints.h.

## Member Data Documentation

## input_normals_

template<typename PointT , typename NormalT >

NormalsPtr pcl::ShadowPoints< PointT, NormalT >::input_normals_

protected

The normals computed at each point in the input cloud.

Definition at line 107 of file shadowpoints.h.

Referenced by pcl::ShadowPoints< PointT, NormalT >::getNormals(), and pcl::ShadowPoints< PointT, NormalT >::setNormals().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/shadowpoints.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/impl/shadowpoints.hpp